#include "FiveWin.ch"
#include "Image.ch"
#include "Tselex.ch"
#include "Ttitle.ch"

// --- from SETTING.ini
STATIC nWStyle, nWColorF, nWColorB, nWGradPos, lWDirect, cWBrush, cWImage
STATIC nDStyle, nDColorF, nDColorB, nDGradPos, lDDirect, cDBrush, cDImage, nDTcolor
STATIC nMStyle, nMColorF, nMColorB, nMGradPos, aMGrad, lMDirect, cMBrush

STATIC oMFont, nMFSize, nMFStyle, nMFColor, lMCenter
STATIC oTMFont, nTMFSize, nTMFStyle, nTMFColor, lTMCenter
STATIC oMDlg1, oMDlg2, nINI := 1, lDlgOpen1 := .F., lDlgOpen2 := .F., lMsgcenter := .T., oCrsHand, oArrow

EXTERNAL TMETER

FUNCTION Main()
LOCAL oFBtn, oIco, oWBrush, nSection := 4, lStartup := .T.
LOCAL nSWidth := GetSysMetrics(0), nSHeight := GetSysMetrics(1)

SET _3DLOOK ON
SetBalloon( .T. )
c_path := cFilePath(GetModuleFileName( GetInstance() ) )
c_path1 := c_path + "IMAGES\"

DEFINE ICON oIco RESOURCE "Super"
oFont := TFont():New("Arial",0,-14,.F.,.F.,0,0,0,.T. )
oFont1 := TFont():New("Arial",0,-16,.F.,.F.,0,0,0,.T. )
oFont2  := TFont():New("Arial",,-24,.F.,.T. ,,,,.T. )

DEFINE CURSOR oCrsHand  RESOURCE "Hand"
DEFINE CURSOR oArrow  RESOURCE "Arrow"

LOAD_INI()

DEFINE WINDOW oWnd  ;
TITLE "Message-Painter  =>   Release 2.1  /  21.10.2013"   MENU TMenu():New()

DEFINE BRUSH oWBrush FILE c_path1 + "Blustone.Bmp"

DEFINE DIALOG oDlg1 FROM nSHeight - 200, 30 TO nSHeight - 90, 735 OF oWnd PIXEL BRUSH oWBrush ;
STYLE nOR( DS_MODALFRAME | WS_POPUP )

@ 5, 5 FOLDEREX oFld VAR nSection SIZE 315, 48 PIXEL ROUND 5 ; // Top, Left, Width, Height
PROMPT  "&Window", "&Dialog", "&Messages", "???" OF oDlg1 ;
BITMAPS "Page", "Page", "Page", "Page" ;
ON CHANGE  ( IIF( nOption == 1 .and. lDlgOpen1 = .T., oMDlg1:End(), NIL ), ;
				   IIF( nOption == 1 .and. lDlgOpen2 = .T., oMDlg2:End(), NIL ), ;
                             lDlgOpen1 = .F., lDlgOpen2 = .F., ;
 				   nSection := oFld:nOption, ;
			           IIF( nSection == 2, SHOW_DLG(), NIL ), ;
			           IIF( nSection == 3, SHOW_MSG(), NIL ), ;
	                           IIF( nSection == 4, ( lStartup := .T., WD_START( oWnd ) ), ;
			                                             ( lStartup := .F., WD_BACKGRD( oWnd, nWStyle, lWDirect, nWColorF, nWColorB, nWGradPos, cWBrush, cWImage ) ) ) )

oFld:lTransparent := .T.
oFld:nFolderHeight := 25
oFld:nSeparator := 2
oFld:nRound := 5
oFld:bClrText := {| o, n | 128 }
oFld:oFont := oFont
oFld:nOption := 4

F_BACKGRD1( oFld ) 

FW_PAGE1( oFld )
FW_PAGE2( oFld )
FW_PAGE3( oFld )
FW_PAGE4( oFld )

@ 8, 322 BTNBMP oFBtn OF oDlg1 ;
SIZE 30, 45 PIXEL 2007 ; // B / H
NOBORDER ;
PROMPT "&Exit" + CRLF + "" ;
FILENAME c_path1 + "Exit.Bmp" ;
ACTION oWnd:End() ;
FONT oFont ;
TOP
oFBtn:lTransparent := .t.
oFBtn:cToolTip =  { "Exit " + CRLF + "Messages","EXIT", 1, CLR_BLACK, 14089979 }
oFBtn:SetColor( 0, )

ACTIVATE DIALOG oDlg1 NOWAIT

SET MESSAGE OF oWnd TO "Testing MESSAGE-styles" ;
CENTERED CLOCK KEYBOARD 2007

ACTIVATE WINDOW oWnd MAXIMIZED ;
ON RESIZE IIF( lStartup = .T., WD_START( oWnd ), ; 
					                     WD_BACKGRD( oWnd, nWStyle, lWDirect, nWColorF, nWColorB, nWGradPos, cWBrush, cWImage ) ) 

SET _3DLOOK OFF
oFont:End()
oFont1:End()
oFont2:End()
oMFont:End()
oEMFont:End()
oIco:End()
oWBrush:End()
oCrsHand:End()
oArrow:End()

RETURN NIL

// -----------------------------

FUNCTION SET_MSGFNT()

IF nTMFStyle = 1
		oTMFont  := TFont():New("Arial",,-16,.F.,.F. ,,,,.F. )
ENDIF
IF nTMFStyle = 2
		oTMFont  := TFont():New("Arial",,-16,.F.,.T. ,,,,.F. )
ENDIF
IF nTMFStyle = 3
		oTMFont  := TFont():New("Arial",,-16,.F.,.F. ,,,,.T. )
ENDIF
IF nTMFStyle = 4
		oTMFont  := TFont():New("Arial",,-16,.F.,.T. ,,,,.T. )
ENDIF

IF nMFStyle = 1
		oMFont  := TFont():New("Arial",,nMFSize,.F.,.F. ,,,,.F. )
ENDIF
IF nMFStyle = 2
		oMFont  := TFont():New("Arial",,nMFSize,.F.,.T. ,,,,.F. )
ENDIF
IF nMFStyle = 3
		oMFont  := TFont():New("Arial",,nMFSize,.F.,.F. ,,,,.T. )
ENDIF
IF nMFStyle = 4
		oMFont  := TFont():New("Arial",,nMFSize,.F.,.T. ,,,,.T. )
ENDIF

RETURN ( NIL )

// ------------------------------

FUNCTION FW_PAGE1( oFld )
LOCAL nStyle := 5, oWSelect1, nWSelect1 := 1, oWSelect2, nWSelect2 := 5

IF nWStyle = 1
		nWSelect1 := 1
ENDIF
IF nWStyle = 2
		nWSelect1 := 2
ENDIF
IF nWStyle = 3
		nWSelect1 := 3
ENDIF
IF nWStyle = 4
		nWSelect1 := 4
ENDIF

@ 2, 30 SELEX oWSelect1 VAR nWSelect1 SIZE 200, 30 OF oFld:aDialogs[ 1 ] PIXEL ;
ITEMS "&Color", "&Gradient", "&Brush", "&Image" ;
GRADIENT OUTTRACK { { 0.5, 16443068, 16312263 }, ;
					   { 0.5, 16312263, 16443068 } } ;
GRADIENT INTRACK { { 1, 5426223, 1071100 }, ;
				      { 1, 1071100, 5426223 } } ;
THUMBSIZE 20, 20 ROUNDSIZE 5 ;
COLOR THUMB 14853684 ;
COLORTEXT 128, 32768 ;
TITLE "Window-Background from INI" TOP ;
FONT oFont ;
ACTION ( nWStyle := oWSelect1:nOption, ;
		         WD_BACKGRD( oWnd, nWStyle, lWDirect, nWColorF, nWColorB, nWGradPos, cWBrush, cWImage ) )

RETURN NIL

// ------------------------------

FUNCTION FW_PAGE2( oFld )
LOCAL oDSelect1, nDSelect1 := 1

IF nDStyle = 1
		nDSelect1 := 1
ENDIF
IF nDStyle = 2
		nDSelect1 := 2
ENDIF
IF nDStyle = 3
		nDSelect1 := 3
ENDIF
IF nDStyle = 4
		nDSelect1 := 4
ENDIF

@ 2, 30 SELEX oDSelect1 VAR nDSelect1 SIZE 200, 30 OF oFld:aDialogs[ 2 ] PIXEL ;
ITEMS "&Color", "&Gradient", "&Brush", "&Image" ;
GRADIENT OUTTRACK { { 0.5, 16443068, 16312263 }, ;
					   { 0.5, 16312263, 16443068 } } ;
GRADIENT INTRACK { { 1, 5426223, 1071100 }, ;
				      { 1, 1071100, 5426223 } } ;
THUMBSIZE 20, 20 ROUNDSIZE 5 ;
COLOR THUMB 14853684 ;
COLORTEXT 128, 32768 ;
TITLE "Dialog-Background from INI" TOP ;
FONT oFont ;
ACTION ( IIF(  lDlgOpen1 = .F., SHOW_DLG(), NIL ), ;
			 nDStyle := oDSelect1:nOption, ;
			 WD_BACKGRD( oMDlg1, nDStyle, lDDirect, nDColorF, nDColorB, nDGradPos, ;
			 cDBrush, cDImage ) )

RETURN NIL

// ------------------------------

FUNCTION FW_PAGE3( oFld )
LOCAL oMSelect1, nMSelect1 := 1

IF nMStyle = 1
		nMSelect1 := 1
ENDIF
IF nMStyle = 2
		nMSelect1 := 2
ENDIF
IF nMStyle = 3
		nMSelect1 := 3
ENDIF
IF nMStyle = 4
		nMSelect1 := 4
ENDIF

@ 2, 30 SELEX oMSelect1 VAR nMSelect1 SIZE 200, 30 OF oFld:aDialogs[ 3 ] PIXEL ;
ITEMS "&Color", "&Grad. H", "&Grad. V", "&Brush" ;
GRADIENT OUTTRACK { { 0.5, 16443068, 16312263 }, ;
					   { 0.5, 16312263, 16443068 } } ;
GRADIENT INTRACK { { 1, 5426223, 1071100 }, ;
				      { 1, 1071100, 5426223 } } ;
THUMBSIZE 20, 20 ROUNDSIZE 5 ;
COLOR THUMB 14853684 ;
COLORTEXT 128, 32768 ; 
TITLE "Message-Background from INI" TOP ;
FONT oFont ;
ACTION  IIF(  lDlgOpen2 = .F., ( SHOW_MSG(), ;
								  WD_BACKGRD( oMDlg2, nDStyle, lDDirect, nDColorF, nDColorB, nDGradPos, ;
								  cDBrush, cDImage ) ), NIL )

RETURN NIL

// ------------------------------

FUNCTION FW_PAGE4( oFld )

@ 8, 10 SAY "Select a FOLDER-option" SIZE 250,15 PIXEL OF oFld:aDialogs[ 4 ] ;
COLOR 255 FONT oFont2 TRANSPARENT

RETURN NIL

// ---------------------------------

FUNCTION SHOW_DLG()
LOCAL oTitle1, oTitle2, oTitle3, oBtn[10], hDC, aRect[4], oBMP[10]

IF lDlgOpen2 = .T.
		oMDlg2:End()
ENDIF
lDlgOpen1 := .T.

DEFINE DIALOG oMDlg1 FROM 50, 30 TO 540, 735 OF oWnd PIXEL ;
STYLE nOR( DS_MODALFRAME | WS_POPUP )

ACTIVATE DIALOG oMDlg1 NOWAIT ;
ON INIT ( oMDlg1:Move( 50, 30, oMDlg1:nWidth, oMDlg1:nHeight, .f. ), ;
                  aRect[1] := oMDlg1:nTop, aRect[2] := oMDlg1:nLeft, ;
	                aRect[3] := oMDlg1:nHeight, aRect[4] := oMDlg1:nWidth, ;
			WD_BACKGRD( oMDlg1, nDStyle, lDDirect, nDColorF, nDColorB, nDGradPos, ;
							cDBrush, cDImage ) )

RETURN NIL

// ---------------------------------

FUNCTION SHOW_MSG()
LOCAL oBtn[10], hDC, aRect[4], oTitle1, oTitle2, oBmp[4]
IF lDlgOpen1 = .T.
		oMDlg1:End()
ENDIF
lDlgOpen2 := .T.

DEFINE DIALOG oMDlg2 FROM 50, 30 TO 540, 735 OF oWnd PIXEL ;
STYLE nOR( DS_MODALFRAME | WS_POPUP )

@ 2, 0 TITLE oTitle1 size 360, 15  OF oMDlg2 BORDER
oTitle1:nShadow := 0
oTitle1:lRound := .F.	// Round
oTitle1:aGrdBack := { { 0.3, 14853684, 16314573 }, { 0.3, 16314573, 14853684 } }
oTitle1:nShadowIntensity := 20
oTitle1:lTransparent := .F.
@  12,  320 TITLETEXT OF oTitle1 TEXT "Message-styles ...." FONT oFont1 COLOR 128
@  10, 20 TITLEIMG OF oTitle1 BITMAP c_path1 + "Info.bmp" SIZE 24, 24 ANIMA

@ 195, 20 TITLE oTitle2 size 170, 12  OF oMDlg2 BORDER
oTitle2:nShadow := 0
oTitle2:lRound := .F.	// Round
oTitle2:aGrdBack := { { 0.3, 14853684, 16314573 }, { 0.3, 16314573, 14853684 } }
oTitle2:nShadowIntensity := 20
oTitle2:lTransparent := .F.
@  10, 65 TITLETEXT OF oTitle2 TEXT "Message-brushes from INI ...." FONT oFont1 COLOR 128
@  10, 8 TITLEIMG OF oTitle2 BITMAP c_path1 + "Info.bmp" SIZE 24, 24 ANIMA

@ 210, 15  BITMAP oBmp[1] FILENAME NIL OF oMDlg2 ;
SIZE 40, 30  PIXEL  ADJUST BORDER
oBmp[1]:cTooltip := "Message-Brush 1"
oBmp[1]:bPainted := { |hDC| DRAW_BMP( oBmp[1], hDC, 1, nMColorF, nMColorB, nMGradPos ) }

@ 210, 60  BITMAP oBmp[2] FILENAME NIL OF oMDlg2 ;
SIZE 40, 30 PIXEL  ADJUST BORDER
oBmp[2]:cTooltip := "Message-Brush 2"
oBmp[2]:bPainted := { |hDC| DRAW_BMP( oBmp[2], hDC, 2, nMColorF, nMColorB, nMGradPos, .F. ) }

@ 210, 105  BITMAP oBmp[3] FILENAME NIL OF oMDlg2 ;
SIZE 40, 30 PIXEL  ADJUST BORDER
oBmp[3]:cTooltip := "Message-Brush 3"
oBmp[3]:bPainted := { |hDC| DRAW_BMP( oBmp[3], hDC, 3, nMColorF, nMColorB, nMGradPos, .T. ) }

@ 210, 150 BITMAP oBmp[4] FILENAME NIL OF oMDlg2 ;
SIZE 40, 30 PIXEL  ADJUST BORDER
oBmp[4]:cTooltip := "Message-Brush 4"
oBmp[4]:bPainted := { |hDC| DRAW_BMP( oBmp[4], hDC, 4, , , , , cMBrush ) }

@ 25, 270  BTNBMP oBtn[1] SIZE 70, 20  OF oMDlg2 PIXEL 2007 ROUND NOBORDER;
PROMPT " &Alert            " ;
FILENAME c_path1 + "Info.Bmp" ;
ACTION MESSAGES( lMsgcenter, aRect, 1) ;
FONT oFont  ;
LEFT
oBtn[1]:lTransparent := .t.
oBtn[1]:cToolTip =  { "Message" + CRLF + "Alert","MESSAGE", 1, CLR_BLACK, 14089979 }
oBtn[1]:SetColor( 0, )

@ 48, 270  BTNBMP oBtn[2] SIZE 70, 20 OF oMDlg2 PIXEL 2007 ROUND NOBORDER;
PROMPT " &Wait             " ;
FILENAME c_path1 + "Info.Bmp" ;
ACTION  MESSAGES(lMsgcenter, aRect, 2) ;
FONT oFont  ;
LEFT
oBtn[2]:lTransparent := .t.
oBtn[2]:cToolTip =  { "Message" + CRLF + "Alert","MESSAGE", 1, CLR_BLACK, 14089979 }
oBtn[2]:SetColor( 0, )

@ 71, 270  BTNBMP oBtn[3] SIZE 70, 20 OF oMDlg2 PIXEL 2007 ROUND NOBORDER;
PROMPT " &Meter           " ;
FILENAME c_path1 + "Info.Bmp" ;
ACTION  MESSAGES(lMsgcenter, aRect, 3)  ;
FONT oFont  ;
LEFT
oBtn[3]:lTransparent := .t.
oBtn[3]:cToolTip =  { "Message" + CRLF + "Alert","MESSAGE", 1, CLR_BLACK, 14089979 }
oBtn[3]:SetColor( 0, )

@ 94, 270  BTNBMP oBtn[4] SIZE 70, 20 OF oMDlg2 PIXEL 2007 ROUND NOBORDER;
PROMPT " &Option         " ;
FILENAME c_path1 + "Info.Bmp" ;
ACTION MESSAGES(lMsgcenter, aRect, 4)  ;
FONT oFont  ;
LEFT
oBtn[4]:lTransparent := .t.
oBtn[4]:cToolTip =  { "Message" + CRLF + "Alert","MESSAGE", 1, CLR_BLACK, 14089979 }
oBtn[4]:SetColor( 0, )

@ 117, 270  BTNBMP oBtn[5] SIZE 70, 20 OF oMDlg2 PIXEL 2007 ROUND NOBORDER;
PROMPT " &Table           " ;
FILENAME c_path1 + "Info.Bmp" ;
ACTION  MESSAGES(lMsgcenter, aRect, 5)  ;
FONT oFont  ;
LEFT
oBtn[5]:lTransparent := .t.  
oBtn[5]:cToolTip =  { "Message" + CRLF + "Alert","MESSAGE", 1, CLR_BLACK, 14089979 }
oBtn[5]:SetColor( 0, )

@ 140, 270  BTNBMP oBtn[6] SIZE 70, 20 OF oMDlg2 PIXEL 2007 ROUND NOBORDER;
PROMPT " &Bitmap         " ;
FILENAME c_path1 + "Info.Bmp" ;
ACTION MESSAGES(lMsgcenter, aRect, 6)  ;
FONT oFont  ;
LEFT
oBtn[6]:lTransparent := .t. 
oBtn[6]:cToolTip =  { "Message" + CRLF + "Alert","MESSAGE", 1, CLR_BLACK, 14089979 }
oBtn[6]:SetColor( 0, )

@ 163, 270  BTNBMP oBtn[7] SIZE 70, 20 OF oMDlg2 PIXEL 2007 ROUND NOBORDER;
PROMPT " Enter &Value" ;
FILENAME c_path1 + "Info.Bmp" ;
ACTION MESSAGES(lMsgcenter, aRect, 7)  ;
FONT oFont  ;
LEFT
oBtn[7]:lTransparent := .t. 
oBtn[7]:cToolTip =  { "Message" + CRLF + "Value","MESSAGE", 1, CLR_BLACK, 14089979 }
oBtn[7]:SetColor( 0, )

@ 186, 270  BTNBMP oBtn[8] SIZE 70, 20 OF oMDlg2 PIXEL 2007 ROUND NOBORDER;
PROMPT " Enter &Date" ;
FILENAME c_path1 + "Info.Bmp" ;
ACTION MESSAGES(lMsgcenter, aRect, 8)  ;
FONT oFont  ;
LEFT
oBtn[8]:lTransparent := .t.
oBtn[8]:cToolTip =  { "Message" + CRLF + "Date","MESSAGE", 1, CLR_BLACK, 14089979 }
oBtn[8]:SetColor( 0, )

@ 209, 270  BTNBMP oBtn[9] SIZE 70, 20 OF oMDlg2 PIXEL 2007 ROUND NOBORDER;
PROMPT " Enter &Name" ;
FILENAME c_path1 + "Info.Bmp" ;
ACTION MESSAGES(lMsgcenter, aRect, 9)  ;
FONT oFont  ;
LEFT
oBtn[9]:lTransparent := .t. 
oBtn[9]:cToolTip =  { "Message" + CRLF + "Name","MESSAGE", 1, CLR_BLACK, 14089979 }
oBtn[9]:SetColor( 0, )

ACTIVATE DIALOG oMDlg2 NOWAIT ;
ON INIT ( oMDlg2:Move( 50, 30, oMDlg2:nWidth, oMDlg2:nHeight, .f. ), ;
                  aRect[1] := oMDlg2:nTop, aRect[2] := oMDlg2:nLeft, ;
	                aRect[3] := oMDlg2:nHeight, aRect[4] := oMDlg2:nWidth, ;
			WD_BACKGRD( oMDlg2, nDStyle, lDDirect, nDColorF, nDColorB, nDGradPos, ;
							cDBrush, cDImage ) )

RETURN NIL

// --------  WINDOW - Startup ---------------

FUNCTION WD_START( oWnd )
local oImage, oBrush

IF FILE( c_path1 + "Option.jpg" )
		IF lDlgOpen1 = .T.
			oMDlg1:End()
			lDlgOpen1 := .F. 
		ENDIF
		IF lDlgOpen2 = .T.
			oMDlg2:End()
			lDlgOpen2 := .F. 
		ENDIF

		DEFINE IMAGE oImage FILE c_path1 + "Option.jpg"
		oBrush := TBrush():new( ,,,, ResizeBmp( oImage:hBitmap, oWnd:nWidth, oWnd:nHeight , .T. ) ) 
		oImage:End()
		oWnd:SetBrush( oBrush )
		oBrush:End()
ELSE
		MsgAlert( "File : " + cImage + CRLF + ;
				   "does not exist" + CRLF + ;
				   "to show Image !", "ATTENTION" ) 
ENDIF

RETURN( NIL )

// --------  WINDOW / DIALOG- Background ---------------

FUNCTION WD_BACKGRD( oWnd, nStyle, lDirect, nColor1, nColor2, nMove, cBrush, cImage )
LOCAL oBrush, oImg, aRect := GETCLIENTRECT( oWnd:hWnd )

IF nStyle = 1 // COLOR
		DEFINE BRUSH oBrush COLOR nColor1
ENDIF
IF nStyle = 2 // GRADIENT
		aGrad := { { nMove, nColor1, nColor2 }, { nMove, nColor2, nColor1 } }
		DEFINE BRUSH oBrush GRADIENT aGrad ;
		STYLE ( If( lDirect = .T., "VERTICAL", "HORIZONTAL" ) )
ENDIF
IF nStyle = 3 // BMP-BRUSH
		IF FILE( c_path1 + cBrush )
			DEFINE BRUSH oBrush FILE c_path1 + cBrush
		ELSE
			MsgAlert( "File : " + cBrush + CRLF + ;
					"does not exist" + CRLF + ;
					"to create Brush !", "ATTENTION" )
		ENDIF
ENDIF
IF nStyle = 4 // Image ADJUSTED
		IF FILE( c_path1 + cImage )
			DEFINE IMAGE oImage FILE c_path1 + cImage
			oBrush := TBrush():new( ,,,, ResizeBmp( oImage:hBitmap, aRect[4], aRect[3], .T. ) ) 
			oImage:End()
		ELSE
			MsgAlert( "File : " + cImage + CRLF + ;
					"does not exist" + CRLF + ;
					"to show Image !", "ATTENTION" )
		ENDIF
ENDIF

oWnd:SetBrush( oBrush )
oBrush:End()

RETURN( NIL )

// --------  FOLDER - Backgrounds ---------------

FUNCTION F_BACKGRD1( oFld ) 
LOCAL n, oDlg, hDC, oBrush, oImage, nRow := 0, nCol := 0, lFound := .T.
PixelX := 0.3
PixelY := 0.3

IF lFound = .T.
		FOR n := 1 to Len( oFld:aDialogs ) 
			oDlg := oFld:aDialogs[ n ]
			hDC = CreateCompatibleDC( oDlg:GetDC() )
			IF !FILE( c_path1 + "Marble.bmp" )
				MsgAlert( "File : " + c_path + "Marble.bmp" + CRLF + ;
						"does not exist to create" + CRLF + ;
						"Brush-Background !", "ATTENTION" )
				lFound := .F.
			ELSE
				DEFINE BRUSH oBrush FILENAME c_path1 + "Marble.bmp" 
				oDlg:SetBrush( oBrush )
			ENDIF
			IF lFound = .T.
				RELEASE BRUSH oBrush
				ReleaseDC(hDC)
			ENDIF
		NEXT
ENDIF

RETURN( NIL )

// ------------------------

FUNCTION MESSAGES(lMsgcenter, aRect, nMsgSelect)
LOCAL aMGradient := {}, cBrush := "", oFont, nTColor
LOCAL nOpt := 0, oIcon, cLines := "", cOpted := ""
LOCAL uVar := 0, cPict, bValid, bAction, lGDirect := .F.

/*
FUNCTION MyMsgBox(  lPosition, aRect, ;
    3     cMsg, ;
    4     aOptions, ;
    5     cTitle, ;
    6     xIcon, ;
    7     nDefault, ;
    8     aGradiate, ;
    9     lGradDir, ;
   10    cBrush, ;
   11    bAction, ;
   12    oFont, ;
   13    nFColor, ;
   14    cFileRes, ;
   15    oIcon, ;
   16    uVar, ;
   17    cPict, ;
   18    bValid, ;
   19    lSpinner, ;
   20    lMeter, ;
   21    oMeter, ;
   22    lCancel), ;
*/

IF cMStyleSel = "EM" // from Source
		IF nEMStyle = 1
			aMGradient := {{ 0.8,16711680,16711680 },{ 0.8,16711680, 16711680}} 
			cBrush := ""
		ENDIF
		IF nEMStyle = 2
			aMGradient := {{ 0.8,16711680,16777215 },{ 0.8,16777215, 16711680}} 
			lGDirect := .F.
			cBrush := ""
		ENDIF
		IF nEMStyle = 3
			aMGradient := {{ 0.8,16711680,16777215 },{ 0.8,16777215, 16711680}} 
			lGDirect := .T.
			cBrush := ""
		ENDIF
		IF nEMStyle = 4
			aMGradient := {}
			lGDirect := .F.
			cBrush := c_path1 + "beach.bmp"
		ENDIF
		oFont := oEMFont
		nTColor := 10485760
ENDIF

IF cMStyleSel = "M" // from INI
		IF nMStyle = 1
			aMGradient := {{ nMGradPos, nMColorF, nMColorF },{ nMGradPos, nMColorF, nMColorF }} 
			cBrush := ""
		ENDIF
		IF nMStyle = 2
			aMGradient := {{ nMGradPos, nMColorF, nMColorB },{ nMGradPos, nMColorB, nMColorF }}
			lGDirect := .F.
			cBrush := ""
		ENDIF
		IF nMStyle = 3
			aMGradient := {{ nMGradPos, nMColorF, nMColorB },{ nMGradPos, nMColorB, nMColorF }}
			lGDirect := .T.
			cBrush := ""
		ENDIF
		IF nMStyle = 4
			aMGradient := {}
			cBrush := c_path1 + ALLTRIM(cEMBrush)
		ENDIF
		oFont := oMFont
		nTColor := nMTColor
ENDIF

IF  nEMStyle = 5 .and. nMStyle = 5
		aMGradient := {{ 1, 255, 255 },{ 1, 255, 255 }}
		cBrush := ""
		oFont := oMFont
		MYMSGBOX( lMsgcenter, aRect, ;
					"NO Brush selected !."+CRLF+ ;
					"Please select a style between 1 - 4.", , ;
					"Error Message", , , ;
					aMGradient, ;
					lGDirect, ;
					cBrush, , ;
					oFont, ;
					nTColor, , ;
					oIcon)
ELSE
		IF nMsgSelect = 1
// Alert
			MYMSGBOX( lMsgcenter, aRect, ;
						"There is an error and the process could not be completed."+CRLF+ ;
						"Please try it once again.", , ;
						"Error Message", , , ;
						aMGradient, ;
						lGDirect, ;
						cBrush, , ;
						oFont, ;
						nTColor, , ;
						oIcon)
		ENDIF
		IF nMsgSelect = 2
			// Wait
			MYMSGBOX( lMsgcenter, aRect, ;
						"This Message is shown for 3 Seconds.", , ;
						"Wait Message", ;
						"A", , ;
						aMGradient, ;
						lGDirect, ;
						cBrush, ;
						{||SysWait(3)}, ;
						oFont, ;
						nTColor, , ;
						oIcon)
		ENDIF
		IF nMsgSelect = 3
			// Meter
			MsgInfo(MYMSGBOX( lMsgcenter, aRect, ;
					"Counting Numbers from 1 to 100 with a Meter. Please wait ..", , ;
					"Number Counting", ;
					"I", , ;
					aMGradient, ;
					lGDirect, ;
					cBrush, ;
					{|oMeter,lCancel|Count(1,10,oMeter,lCancel)}, ;
					oFont, ;
					nTColor, , ;
					oIcon, , , , , ;
					.T., ;
					oMeter, ;
					@lCancel) )
		ENDIF
		IF nMsgSelect = 4
			// Option
			nOpt := MYMSGBOX( lMsgcenter, aRect, ;
							"Please specify your Option for the output.", ;
							{"&Printer","&File","&Screen","&None"}, ;
							"Output Option", ;
							"Q", , ;
							aMGradient, ;
							lGDirect, ;
							cBrush, , ;
							oFont, ;
							nTColor, , ;
							oIcon )

			IF nOpt = 1
				cOpted := "Printer"
			ENDIF
			IF nOpt = 2
				cOpted := "File"
			ENDIF
			IF nOpt = 3
				cOpted := "Screen"
			ENDIF
			IF nOpt = 4
				cOpted := "None"
			ENDIF
			MYMSGBOX( lMsgcenter, aRect, ;
						"You have opted for < " + cOpted + " >", , ;
						"Option Selected", ;
						"E", , ;
						aMGradient, ;
						lGDirect, ;
						cBrush, , ;
						oFont, ;
						nTColor, ;
						"People", ;
						oIcon )  
		ENDIF
		IF nMsgSelect = 5
			// Table
			cLines := TableMsg()
			DO WHILE nOpt = 0
				nOpt :=  MYMSGBOX( lMsgcenter, aRect, ;
									cLines, ;
									{"&Create","&Cancel"}, ;
									"Table Message", ;
									"Q", ;
									1, ;
									aMGradient, ;
									lGDirect, ;
									cBrush, , ;
									oFont, ;
									nTColor, , ;
									oIcon)
			ENDDO

			IF nOpt = 1
				cOpted := "Create"
			ENDIF
			IF nOpt = 2
				cOpted := "Cancel"
			ENDIF
			MYMSGBOX( lMsgcenter, aRect, ;
						"You have opted for < " + cOpted + " >", , ;
						"Option Selected", ;
						"E", , ;
						aMGradient, ;
						lGDirect, ;
						cBrush, , ;
						oFont, ;
						nTColor, ;
						"People", ;
						oIcon )  
		ENDIF
		IF nMsgSelect = 6
			// Bitmap
			MYMSGBOX( lMsgcenter, aRect, ;
						"Painting a User defined Bitmap on the Message Box", ;
						{"&Ok"}, ;
						"User Defined Bitmap", ;
						"A", ;
						1, ;
						aMGradient, ;
						lGDirect, ;
						cBrush, , ;
						oFont, ;
						nTColor, ;
						c_path1 + "Clock.Bmp", ;
						oIcon)  
		ENDIF
IF nMsgSelect = 7
			// Enter value
			uVar   := 1540.00
			cPict  := "99,999.99"
			bValid := {|o| IF( o:Value > 3000, (MYMSGBOX( lMsgcenter, aRect,"Sorry, You cannot enter a Salary, more than 3,000."),.F.),.T.)}
			MsgInfo( MYMSGBOX( lMsgcenter, aRect, ;
								"Please enter your Salary here below 3000 Dollars", ;
								{"&Ok","&Cancel"}, ;
								"Enter your Salary", , , ;
								aMGradient, ;
								lGDirect, ;
								cBrush, , ;
								oFont, ;
	            						nTColor, , ;
								oIcon, ;
								uVar, ;
								cPict, ;
								bValid, ;
								.F.) )
		ENDIF
		IF nMsgSelect = 8
			// Enter date
			uVar   := DATE()
			cPict  := "99-99-9999"
			bValid := {|o|IF(o:Value > CTOD("31/12/2011"),(MYMSGBOX( lMsgcenter, aRect,"Sorry, You cannot enter a date beyond end of this year."),.F.),.T.)}
			MsgInfo( MYMSGBOX( lMsgcenter, aRect, ;
								"Please enter a Date prior to the end of this year.", ;
								{"&Ok","&Cancel"}, ;
								"Get with Validation", , , ;
								aMGradient, ;
								lGDirect, ;
								cBrush, , ;
								oFont, ;
								nTColor, , ;
								oIcon, ;  
								@uVar, ;
								cPict, ;
								bValid, ;
								.T.) )
		ENDIF
IF nMsgSelect = 9
			// Enter name
			uVar   := SPACE(25)
			cPict  := "@!"
			bValid := {|o|IF(EMPT(o:Value),(MYMSGBOX(  lMsgcenter, aRect,"Sorry, You cannot leave the name empty."),.F.),.T.)}
			MsgInfo( MYMSGBOX( lMsgcenter, aRect, ;
								"Please enter your First Name and Second Name here.", ;
								{"&Ok","&Cancel"}, ;
								"Enter First Name", , , ;
								aMGradient, ;
								lGDirect, ;
								cBrush, , ;
								oFont, ;
								nTColor, , ;
								oIcon, ; 
								@uVar, ;
								cPict, ;
								bValid, ;
								.T.) )
		ENDIF

oFont:End()

ENDIF

RETURN NIL

// ------------------------

FUNCTION TableMsg()
LOCAL array, cLines, n

// Tabular Message
array := {}

AADD(array,padc("1. TITLE",50))
AADD(array,"")
AADD(array,padc("2. TITLE",50))
AADD(array,"")
AADD(array,"-----------------------------------------------------------------------")
AADD(array,"FIELD 1A		FIELD 2A		FIELD 3A")
AADD(array,"FIELD 1B		FIELD 2B		FIELD 3B")
AADD(array,"-----------------------------------------------------------------------")
AADD(array,"VALUE 1A		VALUE 2A		VALUE 3A")
AADD(array,"VALUE 1B		VALUE 2B		VALUE 3B")
AADD(array,"-----------------------------------------------------------------------")

cLines := ""
FOR n = 1 TO LEN(array)
	cLines+= array[n]+CRLF
NEXT

cLines += CRLF
cLines += "Please confirm wether you want to Create Blank Marks as shown above?"
cLines += CRLF+CRLF+CRLF+CRLF

RETURN cLines

// -------------------------

FUNCTION Count(nFrom,nUpto,oMeter)
LOCAL n

DO WHILE .NOT. lCancel .AND. nFrom <= nUpto
	SysWait(.5)
	oMeter:Set(nFrom)
	nFrom++
	IF lCancel
		EXIT
	ENDIF
ENDDO
RETURN NIL

// --------- INI - Read -------------

FUNCTION LOAD_INI()
Local oInifile
Local  cWStyle := "1", cWColorF := "14853684", cWColorB := "16312263", cWGradPos := "0.5", cWDirect := ".T."
Local  cDStyle := "1", cDColorF := "14853684", cDColorB := "16312263", cDGradPos := "0.5", cDTColor := "0", cDDirect := ".T."
Local  cMStyle := "1", cMColorF := "14853684", cMColorB := "16312263", cMGradPos := "0.5", cMDirect := ".T."
Local  cDSource := "1", cMFSize := "-12", cMFStyle := "1", cMTColor := "0", cMsgCenter := ".T."
Local cMsgFont  := TFont():New("Arial",,12,.F.,.F. ,,,,.F. )

IF !FILE ( c_path + "SETTING.ini" )
		MsgAlert( "INI-file missing !", "Error")
ELSE
	INI oInifile FILE c_path + "SETTING.ini"

		GET  cWStyle		SECTION  "Windows"		ENTRY	"Style"			OF oInifile	DEFAULT "1"
		GET  cWColorF		SECTION  "Windows"		ENTRY	"1.Color"		OF oInifile	DEFAULT "14853684"
		GET  cWColorB		SECTION  "Windows"		ENTRY	"2.Color"		OF oInifile	DEFAULT  "16312263"
		GET  cWGradPos	SECTION  "Windows"		ENTRY	"GradPos"		OF oInifile	DEFAULT "0.50"
		GET  cWDirect		SECTION  "Windows"		ENTRY	"Graddirect"	OF oInifile	DEFAULT ".T."
		GET  cWBrush 		SECTION  "Windows"		ENTRY	"Brush"			OF oInifile	DEFAULT  "Marble.bmp"
		GET  cWImage 		SECTION  "Windows"		ENTRY	"Image"			OF oInifile	DEFAULT  "Fantasy2.Jpg"

		GET  cDStyle		SECTION  "Dialog"			ENTRY	"Style"			OF oInifile	DEFAULT "1"
		GET  cDColorF		SECTION  "Dialog"			ENTRY	"1.Color"		OF oInifile	DEFAULT "14853684"
		GET  cDColorB		SECTION  "Dialog"			ENTRY	"2.Color"		OF oInifile	DEFAULT  "16312263"
		GET  cDGradPos	SECTION  "Dialog"			ENTRY	"GradPos"		OF oInifile	DEFAULT "0.50"
		GET  cDDirect		SECTION  "Dialog"			ENTRY	"Graddirect"	OF oInifile	DEFAULT ".T."
		GET  cDBrush 		SECTION  "Dialog"			ENTRY	"Brush"			OF oInifile	DEFAULT  "Marble.bmp"
		GET  cDImage 		SECTION  "Dialog"			ENTRY	"Image"			OF oInifile	DEFAULT  "Fantasy2.Jpg"

		GET  cMStyle		SECTION  "Message"		ENTRY	"Style"			OF oInifile	DEFAULT "1"
		GET  cMColorF		SECTION  "Message"		ENTRY	"1.Color"		OF oInifile	DEFAULT "14853684"
		GET  cMColorB		SECTION  "Message"		ENTRY	"2.Color"		OF oInifile	DEFAULT  "16312263"
		GET  cMGradPos	SECTION  "Message"		ENTRY	"GradPos"		OF oInifile	DEFAULT "0.50"
		GET  cMDirect		SECTION  "Message"		ENTRY	"Graddirect"	OF oInifile	DEFAULT ".T."
		GET  cMBrush 		SECTION  "Message"		ENTRY	"Brush"			OF oInifile	DEFAULT  "Marble.bmp"

          GET  cMsgFont		SECTION  "Message"		ENTRY	"TFont"			OF oInifile	DEFAULT  'TFont():New("Arial",,-14,.F.,.F. ,,,,.F. )'
		GET  cMFSize		SECTION  "Message"		ENTRY	"FontSize"		OF oInifile	DEFAULT "-12"
		GET  cMFStyle		SECTION  "Message"		ENTRY	"FontStyle"		OF oInifile	DEFAULT "1"
		GET  cMTColor		SECTION  "Message"		ENTRY	"FontColor"		OF oInifile	DEFAULT "0"
		GET  cMsgCenter	SECTION  "Message"		ENTRY	"WndCenter"	OF oInifile	DEFAULT ".T."

		lSysini := .F.
	ENDINI
ENDIF

nWStyle		:= VAL(cWStyle)
nWColorF	:= VAL(cWColorF)
nWColorB	:= VAL(cWColorB)
nWGradPos	:= VAL(cWGradPos)
lWDirect		:= .T. // Vertical
IF cWDirect = ".F."
		lWDirect := .F.
ENDIF

nDStyle		:= VAL(cDStyle)
nDColorF	:= VAL(cDColorF)
nDColorB	:= VAL(cDColorB)
nDGradPos	:= VAL(cDGradPos)
lDDirect		:= .T. // Vertical
IF cDDirect = ".F."
		lDDirect := .F.
ENDIF

nMStyle		:= VAL(cMStyle)
nMColorF	 := VAL(cMColorF)
nMColorB	:= VAL(cMColorB)
nMGradPos	:= VAL(cMGradPos)
lMDirect		:= .T. // Vertical
IF cMDirect = ".F."
		lMDirect := .F.
ENDIF
cMFont		:= cMsgFont
nMFSize		:= VAL(cMFSize)
nMFStyle	:= VAL(cMFStyle)
nMTColor	:= VAL(cMTColor)
lMCenter := .T.
IF cMsgCenter = ".F."
		lMCenter := .F.
ENDIF
IF nMFStyle = 1
		oMFont  := TFont():New("Arial",,nMFSize,.F.,.F. ,,,,.F. )
ENDIF
IF nMFStyle = 2
		oMFont  := TFont():New("Arial",,nMFSize,.F.,.T. ,,,,.F. )
ENDIF
IF nMFStyle = 3
		oMFont  := TFont():New("Arial",,nMFSize,.F.,.F. ,,,,.T. )
ENDIF
IF nMFStyle = 4
		oMFont  := TFont():New("Arial",,nMFSize,.F.,.T. ,,,,.T. )
ENDIF

RETURN( NIL )

//------------- BMP-Brush -----------

FUNCTION DRAW_BMP( oBitmap, hDC, nStyle, nVColor, nBColor, nMove, lDirect, cBrush, cImage )

LOCAL aGrad := { { nMove, nVColor, nBColor }, { nMove, nBColor, nVColor } }
LOCAL aRect := GETCLIENTRECT( oBitmap:hWnd )
LOCAL oNewBrush

IF nStyle = 1 // 1. Color
	DEFINE BRUSH oNewbrush COLOR nVColor
	FillRect( oBitmap:hDC, aRect, oNewbrush:hBrush )
	oNewbrush:End()
ENDIF
IF nStyle = 2 // Gradient
	DEFINE BRUSH oNewBrush ;
	COLOR GradientFill( hDC,  0, 0, aRect[3], aRect[4], aGrad, lDirect ) // .T: = Vertical
	oNewbrush:End()
ENDIF
IF nStyle = 3 // Gradient
	DEFINE BRUSH oNewBrush ;
	COLOR GradientFill( hDC,  0, 0, aRect[3], aRect[4], aGrad, lDirect ) // .T: = Vertical
	oNewbrush:End()
ENDIF
IF nStyle = 4 // Brush ( stretched )
	IF FILE( c_path1 + cBrush ) 
		DEFINE BITMAP oNewbrush FILENAME c_path1 + cBrush
                PalBmpDraw( hDC, 0, 0, oNewbrush:hBitmap, , aRect[4], aRect[3], , .T. )
		oNewbrush:End()
	ELSE
		IF !EMPTY(cBrush)
			MsgAlert( "File : " + cBrush + CRLF + ;
					"does not exist" + CRLF + ; 
				        "to create Brush !", "ATTENTION" ) 
		ENDIF
	ENDIF
ENDIF
IF nStyle = 5 // Image
	IF FILE( c_path1 + cImage ) 
		DEFINE IMAGE oNewbrush FILENAME c_path1 + cImage
		PalBmpDraw( hDC, 0, 0, oNewbrush:hBitmap, , aRect[4], aRect[3], , .T. ) 
		oNewbrush:End()
	ELSE
		IF !EMPTY(cImage)
			MsgAlert( "File : " + cImage + CRLF + ;
					"does not exist" + CRLF + ; 
				        "to show Image !", "ATTENTION" ) 
		ENDIF
	ENDIF
ENDIF

RETURN( NIL )
